/**
 * Copyright Jan Newmarch
 * BSD License
 */


import javax.swing.*;  
import java.awt.*;

class Controller {

    public static void main(String args[]) throws Exception {
	
	Switch[] switches = Connection.discoverSwitches();

	JFrame f = new JFrame();
	Container pane = f.getContentPane();
	pane.setLayout(new GridLayout(switches.length, 1));
	
	for (Switch sw: switches) {
	    if (sw instanceof OneGangSwitch) {
		SwingSwitch ssw = new
		    SwingOneGangSwitch((OneGangSwitch) sw);
		pane.add(ssw);
	    } else if (sw instanceof TwoGangSwitch) {
		SwingSwitch ssw = new
		    SwingTwoGangSwitch((TwoGangSwitch) sw);
		pane.add(ssw);
	    } else if (sw instanceof DimmableSwitch) {
		SwingSwitch ssw = new
		    SwingDimmableSwitch((DimmableSwitch) sw);
		pane.add(ssw);
	    }
	}
	
	f.setSize(400,500);
	f.setVisible(true);
    }
}
	
