/**
 * Copyright Jan Newmarch
 * BSD License
 */

import java.lang.Integer;
import java.lang.Byte;

public class DimmableSwitch extends Switch {

    public static final byte ON = 100;
    public static final byte OFF = 0;

    public DimmableSwitch(String names[], byte ID[]) {
	super(names, ID);
	type = 0x04;
	this.state = 0;
    }
    
    public DimmableSwitch(String names[], byte ID[], byte state) {
	super(names, ID);
	this.type = 0x04;
	this.state = state;
    }
    
    public boolean setState(byte newState) {
	byte val = 0, check;
	int checkInt;
	
	if (newState < OFF || newState > ON)
	    return false;

	if (newState <= 0x03) {
	    checkInt = newState + 92; // 0x5c;
	} else if (newState <= 0x0b) {
	    checkInt = newState + 76; // 0x4c;
	} else if (newState <= 0x13) {
	    checkInt = newState + 60; //0x3c;
	} else if (newState <= 0x1b) {
	    checkInt = newState + 44; //0x2c;
	} else if (newState <= 0x23) {
	    checkInt = newState + 92; //0x5c;
	} else if (newState <= 0x2b) {
	    checkInt = newState + 76; //0x4c;
	} else if (newState <= 0x33) {
	    checkInt = newState + 60; //0x3c;
	} else if (newState <= 0x3b) {
	    checkInt = newState + 44; //0x2c;
	} else if (newState <= 0x43) {
	    checkInt = newState - 0x24;
	} else if (newState <= 0x4b) {
	    checkInt = newState - 0x34;
	} else if (newState <= 0x53) {
	    checkInt = newState - 0x44;
	} else if (newState <= 0x5b) {
	    checkInt = newState - 0x54;
	} else if (newState <= 0x63) {
	    checkInt = newState - 0x24;
	} else {
	    checkInt = newState - 0x34;
	}
	check = (byte) checkInt;
	System.out.println("Setting state to " + newState +
			   " checksum (B) " + check +
			   " checksum (I) " + Integer.toHexString(check)
			   );
	boolean ret = Connection.setState(ID, type, newState, check);
	if (ret)
	    state = newState;
	return ret;
    }

}
