/**
 * Copyright Jan Newmarch
 * BSD License
 */

import java.util.Arrays;

public class OneGangSwitch extends Switch {

    public static final byte ON = 1;
    public static final byte OFF = 0;

    public OneGangSwitch(String names[], byte ID[]) {
	super(names, ID);
	type = 0x01;
	this.state = 0;
    }
    
    public OneGangSwitch(String names[], byte ID[], byte state) {
	super(names, ID);
	this.type = 0x01;
	this.state = state;

	System.out.println("New one gang, ID " + Arrays.toString(ID));
    }
    
    public boolean setState(byte newState) {
	byte check;
	
	if (newState != ON && newState != OFF) {
	    System.out.println("Not setting state to " + newState);
	    return false;
	}

	if (newState == ON) {
	    check = (byte) 0xaa;
	} else {
	    check = (byte) 0xa9;
	}
	
	boolean ret = Connection.setState(ID, type, newState, check);
	if (ret)
	    this.state = newState;
	return ret;
    }

}
