/**
 * Copyright Jan Newmarch
 * BSD License
 */

import javax.swing.*;  
import java.awt.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.lang.Integer;

public class SwingDimmableSwitch extends SwingSwitch {

    public SwingDimmableSwitch(DimmableSwitch sw) {
	super(sw);

	JSlider slider = new JSlider(0, 100);

	this.setLayout(new BorderLayout());
	this.add(new JLabel(getNames()[0]), BorderLayout.LINE_START);
	this.add(slider, BorderLayout.CENTER);

	byte state = sw.getState();
	slider.setValue(state);

	slider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent event) {
		    JSlider slider = (JSlider) event.getSource();
		    if (!slider.getValueIsAdjusting()) {
			int value = slider.getValue();
			System.out.println("Slider value " +
					   Integer.toHexString(value));
			if (value >= 0 && value <= 100) {
			    sw.setState((byte) value);
			}
		    }
		}
	    });
    }
}
