/**
 * Copyright Jan Newmarch
 * BSD License
 */

import javax.swing.*;  
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SwingTwoGangSwitch extends SwingSwitch implements ActionListener {

    private JButton left = new JButton();
    private JButton right = new JButton();

    public SwingTwoGangSwitch(TwoGangSwitch sw) {
	super(sw);


	setButtonStrings();
	this.setLayout(new GridLayout(1, 2));
	this.add(left);
	this.add(right);

	left.addActionListener(this);
	right.addActionListener(this);
    }

    public void actionPerformed(ActionEvent e) {
	// toggle the state
	int state = sw.getState();
	System.out.println("Got state " + state); 


	if (e.getSource() == left)
	    switch (state) {
	    case TwoGangSwitch.ON:
		state = TwoGangSwitch.R_ON;
		break;
	    case TwoGangSwitch.L_ON:
		state = TwoGangSwitch.OFF;
		break;
	    case TwoGangSwitch.R_ON:
		state = TwoGangSwitch.ON;
		break;
	    case TwoGangSwitch.OFF:
		state = TwoGangSwitch.L_ON;
		break;
	    }
	// state = (state + 1) % 4;
	else
	    switch (state) {
	    case TwoGangSwitch.ON:
		state = TwoGangSwitch.L_ON;
		break;
	    case TwoGangSwitch.L_ON:
		state = TwoGangSwitch.ON;
		break;
	    case TwoGangSwitch.R_ON:
		state = TwoGangSwitch.OFF;
		break;
	    case TwoGangSwitch.OFF:
		state = TwoGangSwitch.R_ON;
		break;
	    }
	//state = (state + 2) % 4;
  	System.out.println("Setting state to " + state); 
	sw.setState((byte) state);
	
	setButtonStrings();
    }

    private void setButtonStrings() {
	byte state = sw.getState();
	String names[] = sw.getNames();
	switch (state) {
	case TwoGangSwitch.ON:
	    left.setText(names[0] + " ON");
	    right.setText(names[1] + " ON");
	    break;
	case TwoGangSwitch.L_ON:
	    left.setText(names[0] + " ON");
	    right.setText(names[1] + " OFF");
	    break;
	case TwoGangSwitch.R_ON:
	    left.setText(names[0] + " OFF");
	    right.setText(names[1] + " ON");
	    break;
	case TwoGangSwitch.OFF:
	    left.setText(names[0] + " OFF");
	    right.setText(names[1] + " OFF");
	    break;
	}
    }
}
