/**
 * Copyright Jan Newmarch
 * BSD License
 */

public class TwoGangSwitch extends Switch {

    public static final byte ON = 0x03;
    public static final byte L_ON = 0x01;
    public static final byte R_ON = 0x02;
    public static final byte OFF = 0x00;

    public TwoGangSwitch(String names[], byte ID[]) {
	super(names, ID);
	this.type = 0x02;
	this.state = 0;
    }
    
    public TwoGangSwitch(String names[], byte ID[], byte state) {
	super(names, ID);
	this.type = 0x02;
	this.state = state;
    }
    
    public boolean setState(byte newState) {
	byte check;
	
	switch(newState) {
	case OFF:
	    check = -83; // 0xad;
	    break;
	case L_ON:
	    check = -82; // 0xae;
	    break;
	case R_ON:
	    check = -81; // 0xaf;
	    break;
	case ON:
	    check = -96; // 0xa0;
	    break;

	default:
	    return false;
	}

	boolean ret = Connection.setState(ID, type, newState, check);
	if (ret)
	    state = newState;
	return ret;
    }

}
